#!/usr/bin/perl
#
# /rss.pl from phroggy.com 5.06
#
# (C) 2004 Andy Lyttle, all rights reserved.
# This code may be distributed and modified under the terms of
# the GNU General Public License.
# http://phroggy.com/opensource/

BEGIN { push(@INC,'/Users/phroggy/Sites/phroggy.com-opensource/weblib'); }
use Paths;
use Navigation;
use Blog;
use Browser;
use PhroggyHTML;
use XML::RSS;
use strict;
use warnings;

my $rss = new XML::RSS (version => '1.0');
$rss->channel(
  'title'        => 'phroggy.com/opensource',
  'link'         => $Paths::Web{'root'}.GetURI('home'),
  'description'  => GetDescription('home'),
);

# How many entries to show?  Default is 3, override with ?entries=X
# 0 will show all
my $NUM=$Browser::Query{'entries'};
$NUM=3 unless(defined $NUM && $NUM=~/^\d+$/); # no warning if bad, because this is XML

my @list=GetBlogList();
for(my $i=$#list;$i>-1 && $i>($NUM?$#list-$NUM:0);$i--) {
  my $blog=$list[$i];
  my($box)=load DocBox("weblog/$blog");
  next unless($box->Success); # dunno how this could happen
  my $text=HTMLToText($box->Text);
  ($text)=split(/\n+/,$text); # take first paragraph
  $rss->add_item(
    'title'       => Escape($box->Title),
    'link'        => $Paths::Web{'root'}.GetURI('weblog-'.$blog),
    'description' => Escape($text),
    'dc'          => { 'date' => ISODate($box->Date) },
  );
}

$rss->textinput(
  'title'        => 'Weblog Search',
  'description'  => 'Search through archived weblog entries',
  'name'         => 'string',
  'link'         => "$Paths::Web{'root'}$Paths::Web{'cgi'}/blogsearch.pl",
);

my $xml=$rss->as_string;
print "Vary: Accept-language\n";
print "Content-type: application/rss+xml\n";
print 'Content-length: ',length($xml),"\n\n$xml";
exit;

sub ISODate {
  # Arguments: numeric date
  # Returns: date string as YYYY-MM-DD as per ISO 8601 and http://www.w3.org/TR/NOTE-datetime

  my($num)=@_;
  my($d,$m,$y)=(localtime($num))[3,4,5];
  return sprintf '%04u-%02u-%02u',$y+1900,$m+1,$d;
}
